﻿init python:
    class catwalk_cat:
        def __init__(self, name, image):
            self.name = name
            self.image = image
            self.tile = 0
            self.x = 0
            self.y = 0
    class catwalk_dice:
        def __init__(self):
            self.x = 0
            self.y = 0
            self.alpha = 1
            self.number = 1
            self.rolling = 1
            self.available = True
        def roll(self):
            self.number = random.randint(1,6)
            self.rolling += 1
            if self.rolling > 20:
                self.rolling = 0
        def start_rolling(self):
            self.rolling = 1

    class catwalk_tile:
        def __init__(self, x, y, tile = None, item = None):
            self.x = x
            self.y = y
            self.tile = tile
            self.item = item

    class catwalk_class:
        def __init__(self, tiles):
            self.tiles = tiles
            self.x = 32
            self.y = 16
            self.cats = [catwalk_cat("Princess", "catwalk_princess")]
            self.dices = [catwalk_dice(), catwalk_dice(), catwalk_dice()]
            self.playing_dice = 0
        def play(self, n):
            dice = self.dices[n]
            dice.rolling = 0
            dice.available = False
            dice.x = random.randint(-10,10)
            dice.y = -40
            dice.alpha = 0
            self.playing_dice = dice.number
            Show("catwalk_movng", g = self)()
        def move(self):
            if self.playing_dice and self.cats[0].tile < len(self.tiles)-1:
                renpy.play("catwalk/jump.ogg", "sound")
                self.playing_dice -= 1
                cat = self.cats[0]
                cat.tile += 1
                tile = self.tiles[cat.tile]
                cat.x = tile.x
                cat.y = tile.y
            else:
                Hide("catwalk_movng")()
                Show("catwalk_check", g = self)()
                for i in self.dices:
                    if not i.available:
                        i.x = 0
                        i.y = 0
                        i.alpha = 1
                        i.start_rolling()
                        i.available = True
        def check_tile(self):
            tile = self.tiles[self.cats[0].tile]
            if tile.item:
                renpy.notify(tile.item)
            Hide("catwalk_check")()

screen catwalk_screen(g):
    modal True
    add "#378493"
    frame padding 0,0 xysize 352,100 align .5,.0 background None:
        at zoom(4, True)
        fixed fit_first True align .5,1.0:
            at catwalk_pound_offset(-g.cats[0].y*g.y)
            for i in reversed(g.tiles):
                button xysize 32,32 padding 0,0 align .5,1.0 offset i.x*g.x,i.y*g.y:
                    add i.tile 
                    if i.item:
                        add i.item align .5,.5

            if len(g.cats):
                for i in g.cats:
                    fixed xysize 32,32 align .5,1.0:
                        offset i.x*g.x,i.y*g.y
                        add i.image align .5,.5
        add "catwalk_pound"
    frame:
        align .5,1.0 ysize 600
        background "#379e60"
    frame:
        align 1.0,.5 xsize 280
        background "#379e60"
    frame:
        align .0,.5 xsize 280
        background "#379e60"
    hbox align .5,.5 offset 0,-50 spacing 8:
        at zoom(4, True)
        for n,i in enumerate(g.dices):
            button padding 0,0:
                xysize 16,16 background None
                add f"catwalk_dice_{i.number}" at dice_move(i.x, i.y, i.alpha)
                action Function(g.play, n)
                if i.rolling:
                    timer .1 repeat True action Function(i.roll)

    vbox:
        text str(g.cats[0].tile)
        text str(len(g.tiles))


screen catwalk_movng(g):
    modal True
    timer .4 repeat True action Function(g.move)

screen catwalk_check(g):
    modal True
    timer .4 action Function(g.check_tile)
    text "Checking" align .5,.5

transform dice_move(x,y,a):
    parallel:
        easein_elastic .4 xoffset x yoffset y
    parallel:
        pause .2
        ease .2 alpha a
transform catwalk_pound_offset(y):
    subpixel True
    ease 2 yoffset y



init:
    image catwalk_pound = Crop((0,0,352,128), "catwalk/catwalk.png")

    image catwalk_tile = Crop((0,128,32,32), "catwalk/catwalk.png")
    image catwalk_box = Crop((32,128,32,32), "catwalk/catwalk.png")
    image catwalk_tuna = Crop((64,128,32,32), "catwalk/catwalk.png")
    image catwalk_ball = Crop((96,128,32,32), "catwalk/catwalk.png")
    image catwalk_fight = Crop((128,128,32,32), "catwalk/catwalk.png")

    image catwalk_sandy = Crop((192,128,16,16), "catwalk/catwalk.png")
    image catwalk_kuro = Crop((208,128,16,16), "catwalk/catwalk.png")
    image catwalk_princess = Crop((224,128,16,16), "catwalk/catwalk.png")
    image catwalk_bambino = Crop((240,128,16,16), "catwalk/catwalk.png")

    image catwalk_dice_6 = Crop((256,128,16,16), "catwalk/catwalk.png")
    image catwalk_dice_4 = Crop((272,128,16,16), "catwalk/catwalk.png")
    image catwalk_dice_2 = Crop((288,128,16,16), "catwalk/catwalk.png")
    image catwalk_dice_5 = Crop((256,144,16,16), "catwalk/catwalk.png")
    image catwalk_dice_3 = Crop((272,144,16,16), "catwalk/catwalk.png")
    image catwalk_dice_1 = Crop((288,144,16,16), "catwalk/catwalk.png")



default catwalk_1 = catwalk_class(
    tiles = [
        catwalk_tile(0,0, "catwalk_tile"),
        catwalk_tile(0,-1, "catwalk_tile", "catwalk_fight"),
        catwalk_tile(1,-1, "catwalk_tile"),
        catwalk_tile(2,-1, "catwalk_tile"),
        catwalk_tile(3,-1, "catwalk_tile", "catwalk_box"),
        catwalk_tile(4,-1, "catwalk_tile", "catwalk_tuna"),
        catwalk_tile(4,-2, "catwalk_tile", "catwalk_ball"),
        catwalk_tile(4,-3, "catwalk_tile"),
        catwalk_tile(3,-3, "catwalk_tile"),
        catwalk_tile(2,-3, "catwalk_tile"),
        catwalk_tile(1,-3, "catwalk_tile", "catwalk_kuro"),
        catwalk_tile(0,-3, "catwalk_tile"),
        catwalk_tile(-1,-3, "catwalk_tile"),
        catwalk_tile(-2,-3, "catwalk_tile"),
        catwalk_tile(-2,-4, "catwalk_tile", "catwalk_fight"),
        catwalk_tile(-3,-4, "catwalk_tile"),
        catwalk_tile(-4,-4, "catwalk_tile"),
        catwalk_tile(-4,-5, "catwalk_tile", "catwalk_sandy"),
        catwalk_tile(-4,-6, "catwalk_tile", "catwalk_box"),
        catwalk_tile(-3,-6, "catwalk_tile"),
        catwalk_tile(-3,-7, "catwalk_tile", "catwalk_tuna"),
        catwalk_tile(-3,-8, "catwalk_tile"),
        catwalk_tile(-2,-8, "catwalk_tile", "catwalk_fight"),
        catwalk_tile(-1,-8, "catwalk_tile"),
        catwalk_tile(-0,-8, "catwalk_tile"),
        catwalk_tile(-0,-9, "catwalk_tile"),
        catwalk_tile(1,-9, "catwalk_tile"),
        catwalk_tile(2,-9, "catwalk_tile", "catwalk_bambino"),
        catwalk_tile(3,-9, "catwalk_tile", "catwalk_box"),
        catwalk_tile(4,-9, "catwalk_tile"),
        catwalk_tile(4,-10, "catwalk_tile"),
        catwalk_tile(4,-11, "catwalk_tile", "catwalk_ball"),
        catwalk_tile(4,-12, "catwalk_tile"),
        catwalk_tile(3,-12, "catwalk_tile"),
        catwalk_tile(2,-12, "catwalk_tile", "catwalk_tuna"),
        catwalk_tile(1,-12, "catwalk_tile"),
        catwalk_tile(1,-13, "catwalk_tile"),
        catwalk_tile(1,-14, "catwalk_tile"),
        catwalk_tile(0,-14, "catwalk_tile"),
        catwalk_tile(0,-15, "catwalk_tile", "catwalk_ball"),
        catwalk_tile(0,-16, "catwalk_tile"),
        catwalk_tile(0,-17, "catwalk_tile", "catwalk_fight"),
        catwalk_tile(0,-18, "catwalk_tile"),
    ]
    )


label catwalk_example:
    call screen catwalk_screen(catwalk_1)